Index: trunk/tests/phpunit/tests/general/wpError.php
===================================================================
--- trunk/tests/phpunit/tests/general/wpError.php	(revision 46586)
+++ trunk/tests/phpunit/tests/general/wpError.php	(revision 48858)
@@ -101,5 +101,5 @@
 
 	/**
-	 * @covers ::get_error_codes()
+	 * @covers ::get_error_codes
 	 */
 	public function test_get_error_codes_with_no_errors_should_return_empty_array() {
@@ -108,5 +108,5 @@
 
 	/**
-	 * @covers ::get_error_codes()
+	 * @covers ::get_error_codes
 	 */
 	public function test_get_error_codes_with_one_error_should_return_an_array_with_only_that_code() {
@@ -117,5 +117,5 @@
 
 	/**
-	 * @covers ::get_error_codes()
+	 * @covers ::get_error_codes
 	 */
 	public function test_get_error_codes_with_multiple_errors_should_return_an_array_of_those_codes() {
@@ -129,5 +129,5 @@
 
 	/**
-	 * @covers ::get_error_code()
+	 * @covers ::get_error_code
 	 */
 	public function test_get_error_code_with_no_errors_should_return_an_empty_string() {
@@ -136,5 +136,5 @@
 
 	/**
-	 * @covers ::get_error_code()
+	 * @covers ::get_error_code
 	 */
 	public function test_get_error_code_with_one_error_should_return_that_error_code() {
@@ -145,5 +145,5 @@
 
 	/**
-	 * @covers ::get_error_code()
+	 * @covers ::get_error_code
 	 */
 	public function test_get_error_code_with_multiple_errors_should_return_only_the_first_error_code() {
@@ -155,5 +155,5 @@
 
 	/**
-	 * @covers ::get_error_messages()
+	 * @covers ::get_error_messages
 	 */
 	public function test_get_error_messages_with_empty_code_and_no_errors_should_return_an_empty_array() {
@@ -162,5 +162,5 @@
 
 	/**
-	 * @covers ::get_error_messages()
+	 * @covers ::get_error_messages
 	 */
 	public function test_get_error_messages_with_empty_code_one_error_should_return_an_array_with_that_message() {
@@ -171,5 +171,5 @@
 
 	/**
-	 * @covers ::get_error_messages()
+	 * @covers ::get_error_messages
 	 */
 	public function test_get_error_messages_with_empty_code_multiple_errors_should_return_an_array_of_messages() {
@@ -181,5 +181,5 @@
 
 	/**
-	 * @covers ::get_error_messages()
+	 * @covers ::get_error_messages
 	 */
 	public function test_get_error_messages_with_an_invalid_code_should_return_an_empty_array() {
@@ -188,5 +188,5 @@
 
 	/**
-	 * @covers ::get_error_messages()
+	 * @covers ::get_error_messages
 	 */
 	public function test_get_error_messages_with_one_error_should_return_an_array_with_that_message() {
@@ -197,5 +197,5 @@
 
 	/**
-	 * @covers ::get_error_messages()
+	 * @covers ::get_error_messages
 	 */
 	public function test_get_error_messages_with_multiple_errors_same_code_should_return_an_array_with_all_messages() {
@@ -207,5 +207,5 @@
 
 	/**
-	 * @covers ::get_error_message()
+	 * @covers ::get_error_message
 	 */
 	public function test_get_error_message_with_empty_code_and_no_errors_should_return_an_empty_string() {
@@ -214,5 +214,5 @@
 
 	/**
-	 * @covers ::get_error_message()
+	 * @covers ::get_error_message
 	 */
 	public function test_get_error_message_with_empty_code_and_one_error_should_return_that_message() {
@@ -223,5 +223,5 @@
 
 	/**
-	 * @covers ::get_error_message()
+	 * @covers ::get_error_message
 	 */
 	public function test_get_error_message_with_empty_code_and_multiple_errors_should_return_the_first_message() {
@@ -233,5 +233,5 @@
 
 	/**
-	 * @covers ::get_error_message()
+	 * @covers ::get_error_message
 	 */
 	public function test_get_error_message_with_empty_code_and_multiple_errors_multiple_codes_should_return_the_first_message() {
@@ -244,5 +244,5 @@
 
 	/**
-	 * @covers ::get_error_message()
+	 * @covers ::get_error_message
 	 */
 	public function test_get_error_message_with_invalid_code_and_no_errors_should_return_empty_string() {
@@ -251,5 +251,5 @@
 
 	/**
-	 * @covers ::get_error_message()
+	 * @covers ::get_error_message
 	 */
 	public function test_get_error_message_with_invalid_code_and_one_error_should_return_an_empty_string() {
@@ -260,5 +260,5 @@
 
 	/**
-	 * @covers ::get_error_message()
+	 * @covers ::get_error_message
 	 */
 	public function test_get_error_message_with_invalid_code_and_multiple_errors_should_return_an_empty_string() {
@@ -270,5 +270,5 @@
 
 	/**
-	 * @covers ::get_error_data()
+	 * @covers ::get_error_data
 	 */
 	public function test_get_error_data_with_empty_code_and_no_errors_should_evaluate_as_null() {
@@ -277,5 +277,5 @@
 
 	/**
-	 * @covers ::get_error_data()
+	 * @covers ::get_error_data
 	 */
 	public function test_get_error_data_with_empty_code_one_error_no_data_should_evaluate_as_null() {
@@ -286,5 +286,5 @@
 
 	/**
-	 * @covers ::get_error_data()
+	 * @covers ::get_error_data
 	 */
 	public function test_get_error_data_with_empty_code_multiple_errors_no_data_should_evaluate_as_null() {
@@ -296,5 +296,5 @@
 
 	/**
-	 * @covers ::get_error_data()
+	 * @covers ::get_error_data
 	 */
 	public function test_get_error_data_with_empty_code_and_one_error_with_data_should_return_that_data() {
@@ -306,5 +306,5 @@
 
 	/**
-	 * @covers ::get_error_data()
+	 * @covers ::get_error_data
 	 */
 	public function test_get_error_data_with_empty_code_and_multiple_errors_different_codes_should_return_the_last_data_of_the_first_code() {
@@ -317,5 +317,5 @@
 
 	/**
-	 * @covers ::get_error_data()
+	 * @covers ::get_error_data
 	 */
 	public function test_get_error_data_with_empty_code_and_multiple_errors_same_code_should_return_the_last_data_of_the_first_code() {
@@ -328,5 +328,5 @@
 
 	/**
-	 * @covers ::get_error_data()
+	 * @covers ::get_error_data
 	 */
 	public function test_get_error_data_with_code_and_no_errors_should_evaluate_as_null() {
@@ -335,5 +335,5 @@
 
 	/**
-	 * @covers ::get_error_data()
+	 * @covers ::get_error_data
 	 */
 	public function test_get_error_data_with_code_and_one_error_with_no_data_should_evaluate_as_null() {
@@ -344,5 +344,5 @@
 
 	/**
-	 * @covers ::get_error_data()
+	 * @covers ::get_error_data
 	 */
 	public function test_get_error_data_with_code_and_one_error_with_data_should_return_that_data() {
@@ -354,5 +354,5 @@
 
 	/**
-	 * @covers ::get_error_data()
+	 * @covers ::get_error_data
 	 */
 	public function test_get_error_data_with_code_and_multiple_errors_different_codes_should_return_the_last_stored_data_of_the_code() {
@@ -366,5 +366,5 @@
 
 	/**
-	 * @covers ::get_error_data()
+	 * @covers ::get_error_data
 	 */
 	public function test_get_error_data_with_code_and_multiple_errors_same_code_should_return_the_last_stored_data() {
@@ -377,5 +377,5 @@
 
 	/**
-	 * @covers ::has_errors()
+	 * @covers ::has_errors
 	 */
 	public function test_has_errors_with_no_errors_returns_false() {
@@ -384,5 +384,5 @@
 
 	/**
-	 * @covers ::has_errors()
+	 * @covers ::has_errors
 	 */
 	public function test_has_errors_with_errors_returns_true() {
@@ -392,5 +392,5 @@
 
 	/**
-	 * @covers ::add()
+	 * @covers ::add
 	 */
 	public function test_add_with_empty_code_empty_message_empty_data_should_add_empty_key_to_errors_array() {
@@ -401,5 +401,5 @@
 
 	/**
-	 * @covers ::add()
+	 * @covers ::add
 	 */
 	public function test_add_with_empty_code_empty_message_empty_data_should_add_empty_message_to_errors_array_under_empty_key() {
@@ -410,5 +410,5 @@
 
 	/**
-	 * @covers ::add()
+	 * @covers ::add
 	 */
 	public function test_add_with_empty_code_empty_message_empty_data_should_not_alter_data() {
@@ -419,5 +419,5 @@
 
 	/**
-	 * @covers ::add()
+	 * @covers ::add
 	 */
 	public function test_add_with_empty_code_empty_message_non_empty_data_should_store_data_under_an_empty_code_key() {
@@ -428,5 +428,5 @@
 
 	/**
-	 * @covers ::add()
+	 * @covers ::add
 	 */
 	public function test_add_with_code_empty_message_empty_data_should_add_error_with_code() {
@@ -437,5 +437,5 @@
 
 	/**
-	 * @covers ::add()
+	 * @covers ::add
 	 */
 	public function test_add_with_code_empty_message_empty_data_should_add_error_with_empty_message() {
@@ -446,5 +446,5 @@
 
 	/**
-	 * @covers ::add()
+	 * @covers ::add
 	 */
 	public function test_add_with_code_empty_message_empty_data_should_not_add_error_data() {
@@ -455,5 +455,5 @@
 
 	/**
-	 * @covers ::add()
+	 * @covers ::add
 	 */
 	public function test_add_with_code_and_message_and_empty_data_should_should_add_error_with_that_message() {
@@ -464,5 +464,5 @@
 
 	/**
-	 * @covers ::add()
+	 * @covers ::add
 	 */
 	public function test_add_with_code_and_message_and_empty_data_should_not_alter_stored_data() {
@@ -473,5 +473,5 @@
 
 	/**
-	 * @covers ::add()
+	 * @covers ::add
 	 */
 	public function test_add_with_code_and_empty_message_and_data_should_add_error_with_that_code() {
@@ -482,5 +482,5 @@
 
 	/**
-	 * @covers ::add()
+	 * @covers ::add
 	 */
 	public function test_add_with_code_and_empty_message_and_data_should_store_that_data() {
@@ -491,5 +491,5 @@
 
 	/**
-	 * @covers ::add()
+	 * @covers ::add
 	 */
 	public function test_add_with_code_and_message_and_data_should_add_an_error_with_that_code() {
@@ -500,5 +500,5 @@
 
 	/**
-	 * @covers ::add()
+	 * @covers ::add
 	 */
 	public function test_add_with_code_and_message_and_data_should_add_an_error_with_that_message() {
@@ -509,5 +509,5 @@
 
 	/**
-	 * @covers ::add()
+	 * @covers ::add
 	 */
 	public function test_add_with_code_and_message_and_data_should_store_that_data() {
@@ -518,5 +518,5 @@
 
 	/**
-	 * @covers ::add()
+	 * @covers ::add
 	 */
 	public function test_add_multiple_times_with_the_same_code_should_add_additional_messages_for_that_code() {
@@ -530,5 +530,5 @@
 
 	/**
-	 * @covers ::add()
+	 * @covers ::add
 	 */
 	public function test_add_multiple_times_with_the_same_code_and_different_data_should_store_only_the_last_added_data() {
@@ -540,5 +540,5 @@
 
 	/**
-	 * @covers ::add_data()
+	 * @covers ::add_data
 	 */
 	public function test_add_data_with_empty_data_empty_code_should_create_orphaned_data_with_no_error() {
@@ -549,5 +549,5 @@
 
 	/**
-	 * @covers ::add_data()
+	 * @covers ::add_data
 	 */
 	public function test_add_data_with_empty_data_empty_code_no_errors_should_create_data_under_an_empty_code_key() {
@@ -558,5 +558,5 @@
 
 	/**
-	 * @covers ::add_data()
+	 * @covers ::add_data
 	 */
 	public function test_add_data_with_data_empty_code_and_one_error_should_store_the_data_under_that_code() {
@@ -568,5 +568,5 @@
 
 	/**
-	 * @covers ::add_data()
+	 * @covers ::add_data
 	 */
 	public function test_add_data_with_data_empty_code_and_multiple_errors_with_different_codes_should_store_it_under_the_first_code() {
@@ -580,5 +580,5 @@
 
 	/**
-	 * @covers ::add_data()
+	 * @covers ::add_data
 	 */
 	public function test_add_data_with_data_empty_code_and_multiple_errors_with_same_code_should_store_it_under_the_first_code() {
@@ -593,5 +593,5 @@
 
 	/**
-	 * @covers ::add_data()
+	 * @covers ::add_data
 	 */
 	public function test_add_data_with_data_and_code_and_no_errors_should_create_orphaned_data_with_no_error() {
@@ -602,5 +602,5 @@
 
 	/**
-	 * @covers ::add_data()
+	 * @covers ::add_data
 	 */
 	public function test_add_data_with_data_and_code_no_errors_should_create_data_under_that_code_key() {
@@ -611,5 +611,5 @@
 
 	/**
-	 * @covers ::add_data()
+	 * @covers ::add_data
 	 */
 	public function test_add_data_with_data_and_code_one_error_different_code_should_create_orphaned_data_with_no_error() {
@@ -622,5 +622,5 @@
 
 	/**
-	 * @covers ::add_data()
+	 * @covers ::add_data
 	 */
 	public function test_add_data_with_data_and_code_one_error_different_code_should_create_data_under_that_code_key() {
@@ -633,5 +633,5 @@
 
 	/**
-	 * @covers ::add_data()
+	 * @covers ::add_data
 	 */
 	public function test_add_data_with_data_and_code_should_add_data() {
@@ -644,5 +644,5 @@
 
 	/**
-	 * @covers ::remove()
+	 * @covers ::remove
 	 */
 	public function test_remove_with_no_errors_should_affect_nothing() {
@@ -657,5 +657,5 @@
 
 	/**
-	 * @covers ::remove()
+	 * @covers ::remove
 	 */
 	public function test_remove_empty_code_no_errors_should_affect_nothing() {
@@ -670,5 +670,5 @@
 
 	/**
-	 * @covers ::remove()
+	 * @covers ::remove
 	 */
 	public function test_remove_empty_code_and_one_error_with_empty_string_code_should_remove_error() {
@@ -685,5 +685,5 @@
 
 	/**
-	 * @covers ::remove()
+	 * @covers ::remove
 	 */
 	public function test_remove_empty_code_and_one_error_with_empty_string_code_should_remove_error_data() {
@@ -698,5 +698,5 @@
 
 	/**
-	 * @covers ::remove()
+	 * @covers ::remove
 	 */
 	public function test_remove_should_remove_the_error_with_the_given_code() {
@@ -709,5 +709,5 @@
 
 	/**
-	 * @covers ::remove()
+	 * @covers ::remove
 	 */
 	public function test_remove_should_remove_the_error_data_associated_with_the_given_code() {