Index: /trunk/tests/phpunit/tests/customize/manager.php
===================================================================
--- /trunk/tests/phpunit/tests/customize/manager.php	(revision 49116)
+++ /trunk/tests/phpunit/tests/customize/manager.php	(revision 49117)
@@ -3614,5 +3614,5 @@
 		$this->manager->register_controls();
 		$setting   = $this->manager->get_setting( 'external_header_video' );
-		$video_url = 'https://www.youtube.com/watch?v=KiS8rZBeIO0';
+		$video_url = 'https://www.youtube.com/watch?v=72xdCU__XCk';
 
 		$whitespaces = array(
Index: /trunk/tests/phpunit/tests/formatting/MakeClickable.php
===================================================================
--- /trunk/tests/phpunit/tests/formatting/MakeClickable.php	(revision 49116)
+++ /trunk/tests/phpunit/tests/formatting/MakeClickable.php	(revision 49117)
@@ -290,5 +290,5 @@
 			"http://trunk.domain/testing#something
 			(<img src='http://trunk.domain/wp-includes/images/smilies/icon_smile.gif' alt=':)' class='wp-smiley'>)",
-			"<span style='text-align:center; display: block;'><object width='425' height='350'><param name='movie' value='http://www.youtube.com/v/nd_BdvG43rE&rel=1&fs=1&showsearch=0&showinfo=1&iv_load_policy=1' /> <param name='allowfullscreen' value='true' /> <param name='wmode' value='opaque' /> <embed src='http://www.youtube.com/v/nd_BdvG43rE&rel=1&fs=1&showsearch=0&showinfo=1&iv_load_policy=1' type='application/x-shockwave-flash' allowfullscreen='true' width='425' height='350' wmode='opaque'></embed> </object></span>",
+			"<span style='text-align:center; display: block;'><object width='425' height='350'><param name='movie' value='https://www.youtube.com/watch?v=72xdCU__XCk&rel=1&fs=1&showsearch=0&showinfo=1&iv_load_policy=1' /> <param name='allowfullscreen' value='true' /> <param name='wmode' value='opaque' /> <embed src='https://www.youtube.com/watch?v=72xdCU__XCk&rel=1&fs=1&showsearch=0&showinfo=1&iv_load_policy=1' type='application/x-shockwave-flash' allowfullscreen='true' width='425' height='350' wmode='opaque'></embed> </object></span>",
 			'<a href="http://example.com/example.gif" title="Image from http://example.com">Look at this image!</a>',
 		);
@@ -299,5 +299,5 @@
 			"<a href=\"http://trunk.domain/testing#something\" rel=\"nofollow\">http://trunk.domain/testing#something</a>
 			(<img src='http://trunk.domain/wp-includes/images/smilies/icon_smile.gif' alt=':)' class='wp-smiley'>)",
-			"<span style='text-align:center; display: block;'><object width='425' height='350'><param name='movie' value='http://www.youtube.com/v/nd_BdvG43rE&rel=1&fs=1&showsearch=0&showinfo=1&iv_load_policy=1' /> <param name='allowfullscreen' value='true' /> <param name='wmode' value='opaque' /> <embed src='http://www.youtube.com/v/nd_BdvG43rE&rel=1&fs=1&showsearch=0&showinfo=1&iv_load_policy=1' type='application/x-shockwave-flash' allowfullscreen='true' width='425' height='350' wmode='opaque'></embed> </object></span>",
+			"<span style='text-align:center; display: block;'><object width='425' height='350'><param name='movie' value='https://www.youtube.com/watch?v=72xdCU__XCk&rel=1&fs=1&showsearch=0&showinfo=1&iv_load_policy=1' /> <param name='allowfullscreen' value='true' /> <param name='wmode' value='opaque' /> <embed src='https://www.youtube.com/watch?v=72xdCU__XCk&rel=1&fs=1&showsearch=0&showinfo=1&iv_load_policy=1' type='application/x-shockwave-flash' allowfullscreen='true' width='425' height='350' wmode='opaque'></embed> </object></span>",
 			'<a href="http://example.com/example.gif" title="Image from http://example.com">Look at this image!</a>',
 		);
Index: /trunk/tests/phpunit/tests/media.php
===================================================================
--- /trunk/tests/phpunit/tests/media.php	(revision 49116)
+++ /trunk/tests/phpunit/tests/media.php	(revision 49117)
@@ -935,5 +935,5 @@
 		$actual = wp_video_shortcode(
 			array(
-				'src' => 'https://www.youtube.com/watch?v=i_cVJgIz_Cs&feature=youtu.be',
+				'src' => 'https://www.youtube.com/watch?v=72xdCU__XCk&feature=youtu.be',
 			)
 		);
@@ -949,9 +949,9 @@
 		$actual = wp_video_shortcode(
 			array(
-				'src' => 'http://www.youtube.com/watch?v=i_cVJgIz_Cs',
-			)
-		);
-
-		$this->assertContains( 'src="https://www.youtube.com/watch?v=i_cVJgIz_Cs', $actual );
+				'src' => 'http://www.youtube.com/watch?v=72xdCU__XCk',
+			)
+		);
+
+		$this->assertContains( 'src="https://www.youtube.com/watch?v=72xdCU__XCk', $actual );
 	}
 
@@ -963,9 +963,9 @@
 		$actual = wp_video_shortcode(
 			array(
-				'src' => 'http://vimeo.com/190372437?blah=meh',
-			)
-		);
-
-		$this->assertContains( 'src="https://vimeo.com/190372437', $actual );
+				'src' => 'http://vimeo.com/76979871?blah=meh',
+			)
+		);
+
+		$this->assertContains( 'src="https://vimeo.com/76979871', $actual );
 		$this->assertNotContains( 'blah=meh', $actual );
 	}
@@ -978,9 +978,9 @@
 		$actual = wp_video_shortcode(
 			array(
-				'src' => 'http://vimeo.com/190372437',
-			)
-		);
-
-		$this->assertContains( 'src="https://vimeo.com/190372437?loop=0', $actual );
+				'src' => 'http://vimeo.com/76979871',
+			)
+		);
+
+		$this->assertContains( 'src="https://vimeo.com/76979871?loop=0', $actual );
 	}
 
@@ -992,10 +992,10 @@
 		$actual = wp_video_shortcode(
 			array(
-				'src'  => 'http://vimeo.com/190372437',
+				'src'  => 'http://vimeo.com/76979871',
 				'loop' => true,
 			)
 		);
 
-		$this->assertContains( 'src="https://vimeo.com/190372437?loop=1', $actual );
+		$this->assertContains( 'src="https://vimeo.com/76979871?loop=1', $actual );
 	}
 
Index: /trunk/tests/phpunit/tests/oembed/filterResult.php
===================================================================
--- /trunk/tests/phpunit/tests/oembed/filterResult.php	(revision 49116)
+++ /trunk/tests/phpunit/tests/oembed/filterResult.php	(revision 49117)
@@ -8,5 +8,5 @@
 		$html = '<p></p><iframe onload="alert(1)"></iframe>';
 
-		$actual = wp_filter_oembed_result( $html, (object) array( 'type' => 'rich' ), 'https://www.youtube.com/watch?v=dQw4w9WgXcQ' );
+		$actual = wp_filter_oembed_result( $html, (object) array( 'type' => 'rich' ), 'https://www.youtube.com/watch?v=72xdCU__XCk' );
 
 		$this->assertSame( $html, $actual );
Index: /trunk/tests/phpunit/tests/oembed/filterTitleAttributes.php
===================================================================
--- /trunk/tests/phpunit/tests/oembed/filterTitleAttributes.php	(revision 49116)
+++ /trunk/tests/phpunit/tests/oembed/filterTitleAttributes.php	(revision 49117)
@@ -12,5 +12,5 @@
 					'type' => 'rich',
 				),
-				'https://www.youtube.com/watch?v=dQw4w9WgXcQ',
+				'https://www.youtube.com/watch?v=72xdCU__XCk',
 				'<p>Foo</p><iframe src=""></iframe><b>Bar</b>',
 			),
@@ -20,5 +20,5 @@
 					'type' => 'rich',
 				),
-				'https://www.youtube.com/watch?v=dQw4w9WgXcQ',
+				'https://www.youtube.com/watch?v=72xdCU__XCk',
 				'<p>Foo</p><iframe title="Hello World" src=""></iframe><b>Bar</b>',
 			),
@@ -29,5 +29,5 @@
 					'title' => 'Hello World',
 				),
-				'https://www.youtube.com/watch?v=dQw4w9WgXcQ',
+				'https://www.youtube.com/watch?v=72xdCU__XCk',
 				'<p>Foo</p>',
 			),
@@ -38,5 +38,5 @@
 					'title' => 'Hello World',
 				),
-				'https://www.youtube.com/watch?v=dQw4w9WgXcQ',
+				'https://www.youtube.com/watch?v=72xdCU__XCk',
 				'<p title="Foo">Bar</p>',
 			),
@@ -47,5 +47,5 @@
 					'title' => 'Hello World',
 				),
-				'https://www.youtube.com/watch?v=dQw4w9WgXcQ',
+				'https://www.youtube.com/watch?v=72xdCU__XCk',
 				'<p>Foo</p><iframe title="Hello World" src=""></iframe><b>Bar</b>',
 			),
@@ -56,5 +56,5 @@
 					'title' => 'Bar',
 				),
-				'https://www.youtube.com/watch?v=dQw4w9WgXcQ',
+				'https://www.youtube.com/watch?v=72xdCU__XCk',
 				'<iframe title="Foo" src=""></iframe>',
 			),
@@ -80,5 +80,5 @@
 				'title' => 'Bar',
 			),
-			'https://www.youtube.com/watch?v=dQw4w9WgXcQ'
+			'https://www.youtube.com/watch?v=72xdCU__XCk'
 		);
 
@@ -97,5 +97,5 @@
 				'title' => 'Bar',
 			),
-			'https://www.youtube.com/watch?v=dQw4w9WgXcQ'
+			'https://www.youtube.com/watch?v=72xdCU__XCk'
 		);
 
Index: /trunk/tests/phpunit/tests/shortcode.php
===================================================================
--- /trunk/tests/phpunit/tests/shortcode.php	(revision 49116)
+++ /trunk/tests/phpunit/tests/shortcode.php	(revision 49117)
@@ -214,7 +214,7 @@
 
 	function test_positional_atts_url() {
-		$out = do_shortcode( '[test-shortcode-tag http://www.youtube.com/watch?v=eBGIQ7ZuuiU]' );
+		$out = do_shortcode( '[test-shortcode-tag https://www.youtube.com/watch?v=72xdCU__XCk]' );
 		$this->assertSame( '', $out );
-		$this->assertSame( array( 0 => 'http://www.youtube.com/watch?v=eBGIQ7ZuuiU' ), $this->atts );
+		$this->assertSame( array( 0 => 'https://www.youtube.com/watch?v=72xdCU__XCk' ), $this->atts );
 		$this->assertSame( 'test-shortcode-tag', $this->tagname );
 	}
Index: /trunk/tests/phpunit/tests/widgets/media-video-widget.php
===================================================================
--- /trunk/tests/phpunit/tests/widgets/media-video-widget.php	(revision 49116)
+++ /trunk/tests/phpunit/tests/widgets/media-video-widget.php	(revision 49117)
@@ -287,5 +287,5 @@
 				'attachment_id' => null,
 				'loop'          => false,
-				'url'           => 'https://www.youtube.com/watch?v=OQSNhk5ICTI',
+				'url'           => 'https://www.youtube.com/watch?v=72xdCU__XCk',
 				'content'       => $content,
 			)
@@ -295,5 +295,5 @@
 		// Custom attributes.
 		$this->assertContains( 'preload="metadata"', $output );
-		$this->assertContains( 'src="https://www.youtube.com/watch?v=OQSNhk5ICTI', $output );
+		$this->assertContains( 'src="https://www.youtube.com/watch?v=72xdCU__XCk', $output );
 		$this->assertContains( $content, $output );
 	}