Index: /trunk/src/wp-includes/user.php
===================================================================
--- /trunk/src/wp-includes/user.php	(revision 51409)
+++ /trunk/src/wp-includes/user.php	(revision 51410)
@@ -3677,6 +3677,5 @@
 	/* translators: Do not translate SITENAME, USER_EMAIL, DESCRIPTION, MANAGE_URL, SITEURL; those are placeholders. */
 	$content = __(
-// phpcs:ignore Generic.WhiteSpace.ScopeIndent.Incorrect, PEAR.Functions.FunctionCallSignature.Indent
-'Howdy,
+		'Howdy,
 
 A user data privacy request has been confirmed on ###SITENAME###:
@@ -3697,7 +3696,5 @@
 	 * Filters the body of the user request confirmation email.
 	 *
-	 * Use {@see 'user_request_confirmed_email_content'} instead.
-	 *
-	 * The email is sent to an administrator when an user request is confirmed.
+	 * The email is sent to an administrator when a user request is confirmed.
 	 *
 	 * The following strings have a special meaning and will get replaced dynamically:
@@ -3709,9 +3706,48 @@
 	 * ###SITEURL###     The URL to the site.
 	 *
-	 * For fulfillment email content use {@see 'user_erasure_fulfillment_email_content'} instead.
-	 *
 	 * @since 4.9.6
-	 *
-	 * @deprecated 5.8.0 Use {@see 'user_request_confirmed_email_content'} instead. For fulfillment email content use {@see 'user_erasure_fulfillment_email_content'} instead.
+	 * @deprecated 5.8.0 Use {@see 'user_request_confirmed_email_content'} instead.
+	 *                   For user erasure fulfillment email content
+	 *                   use {@see 'user_erasure_fulfillment_email_content'} instead.
+	 *
+	 * @param string $content    The email content.
+	 * @param array  $email_data {
+	 *     Data relating to the account action email.
+	 *
+	 *     @type WP_User_Request $request     User request object.
+	 *     @type string          $user_email  The email address confirming a request
+	 *     @type string          $description Description of the action being performed
+	 *                                        so the user knows what the email is for.
+	 *     @type string          $manage_url  The link to click manage privacy requests of this type.
+	 *     @type string          $sitename    The site name sending the mail.
+	 *     @type string          $siteurl     The site URL sending the mail.
+	 *     @type string          $admin_email The administrator email receiving the mail.
+	 * }
+	 */
+	$content = apply_filters_deprecated(
+		'user_confirmed_action_email_content',
+		array( $content, $email_data ),
+		'5.8.0',
+		sprintf(
+			/* translators: 1 & 2: Deprecation replacement options. */
+			__( '%1$s or %2$s' ),
+			'user_request_confirmed_email_content',
+			'user_erasure_fulfillment_email_content'
+		)
+	);
+
+	/**
+	 * Filters the body of the user request confirmation email.
+	 *
+	 * The email is sent to an administrator when a user request is confirmed.
+	 * The following strings have a special meaning and will get replaced dynamically:
+	 *
+	 * ###SITENAME###    The name of the site.
+	 * ###USER_EMAIL###  The user email for the request.
+	 * ###DESCRIPTION### Description of the action being performed so the user knows what the email is for.
+	 * ###MANAGE_URL###  The URL to manage requests.
+	 * ###SITEURL###     The URL to the site.
+	 *
+	 * @since 5.8.0
 	 *
 	 * @param string $content    The email content.
@@ -3728,32 +3764,24 @@
 	 * }
 	 */
-	$content = apply_filters_deprecated(
-		'user_confirmed_action_email_content',
-		array( $content, $email_data ),
-		'5.8.0',
-		sprintf(
-			/* translators: 1 & 2: Deprecation replacement options */
-			__( '%1$s or %2$s' ),
-			'user_request_confirmed_email_content',
-			'user_erasure_fulfillment_email_content'
-		)
-	);
-
-	/**
-	 * Filters the body of the user request confirmation email.
-	 *
-	 * The email is sent to an administrator when an user request is confirmed.
-	 * The following strings have a special meaning and will get replaced dynamically:
-	 *
-	 * ###SITENAME###    The name of the site.
-	 * ###USER_EMAIL###  The user email for the request.
-	 * ###DESCRIPTION### Description of the action being performed so the user knows what the email is for.
-	 * ###MANAGE_URL###  The URL to manage requests.
-	 * ###SITEURL###     The URL to the site.
-	 *
-	 * @since 5.8.0
-	 *
-	 * @param string $content    The email content.
-	 * @param array  $email_data {
+	$content = apply_filters( 'user_request_confirmed_email_content', $content, $email_data );
+
+	$content = str_replace( '###SITENAME###', $email_data['sitename'], $content );
+	$content = str_replace( '###USER_EMAIL###', $email_data['user_email'], $content );
+	$content = str_replace( '###DESCRIPTION###', $email_data['description'], $content );
+	$content = str_replace( '###MANAGE_URL###', esc_url_raw( $email_data['manage_url'] ), $content );
+	$content = str_replace( '###SITEURL###', esc_url_raw( $email_data['siteurl'] ), $content );
+
+	$headers = '';
+
+	/**
+	 * Filters the headers of the user request confirmation email.
+	 *
+	 * @since 5.4.0
+	 *
+	 * @param string|array $headers    The email headers.
+	 * @param string       $subject    The email subject.
+	 * @param string       $content    The email content.
+	 * @param int          $request_id The request ID.
+	 * @param array        $email_data {
 	 *     Data relating to the account action email.
 	 *
@@ -3767,35 +3795,4 @@
 	 * }
 	 */
-	$content = apply_filters( 'user_request_confirmed_email_content', $content, $email_data );
-
-	$content = str_replace( '###SITENAME###', $email_data['sitename'], $content );
-	$content = str_replace( '###USER_EMAIL###', $email_data['user_email'], $content );
-	$content = str_replace( '###DESCRIPTION###', $email_data['description'], $content );
-	$content = str_replace( '###MANAGE_URL###', esc_url_raw( $email_data['manage_url'] ), $content );
-	$content = str_replace( '###SITEURL###', esc_url_raw( $email_data['siteurl'] ), $content );
-
-	$headers = '';
-
-	/**
-	 * Filters the headers of the user request confirmation email.
-	 *
-	 * @since 5.4.0
-	 *
-	 * @param string|array $headers    The email headers.
-	 * @param string       $subject    The email subject.
-	 * @param string       $content    The email content.
-	 * @param int          $request_id The request ID.
-	 * @param array        $email_data {
-	 *     Data relating to the account action email.
-	 *
-	 *     @type WP_User_Request $request     User request object.
-	 *     @type string          $user_email  The email address confirming a request
-	 *     @type string          $description Description of the action being performed so the user knows what the email is for.
-	 *     @type string          $manage_url  The link to click manage privacy requests of this type.
-	 *     @type string          $sitename    The site name sending the mail.
-	 *     @type string          $siteurl     The site URL sending the mail.
-	 *     @type string          $admin_email The administrator email receiving the mail.
-	 * }
-	 */
 	$headers = apply_filters( 'user_request_confirmed_email_headers', $headers, $subject, $content, $request_id, $email_data );
 
@@ -3865,8 +3862,5 @@
 	 * Filters the subject of the email sent when an erasure request is completed.
 	 *
-	 * Use {@see 'user_erasure_fulfillment_email_subject'} instead.
-	 *
 	 * @since 4.9.8
-	 *
 	 * @deprecated 5.8.0 Use {@see 'user_erasure_fulfillment_email_subject'} instead.
 	 *
@@ -3885,5 +3879,10 @@
 	 * }
 	 */
-	$subject = apply_filters_deprecated( 'user_erasure_complete_email_subject', array( $subject, $email_data['sitename'], $email_data ), '5.8.0', 'user_erasure_fulfillment_email_subject' );
+	$subject = apply_filters_deprecated(
+		'user_erasure_complete_email_subject',
+		array( $subject, $email_data['sitename'], $email_data ),
+		'5.8.0',
+		'user_erasure_fulfillment_email_subject'
+	);
 
 	/**
@@ -3910,6 +3909,5 @@
 	/* translators: Do not translate SITENAME, SITEURL; those are placeholders. */
 	$content = __(
-// phpcs:ignore Generic.WhiteSpace.ScopeIndent.Incorrect, PEAR.Functions.FunctionCallSignature.Indent
-'Howdy,
+		'Howdy,
 
 Your request to erase your personal data on ###SITENAME### has been completed.
@@ -3925,6 +3923,5 @@
 		/* translators: Do not translate SITENAME, SITEURL, PRIVACY_POLICY_URL; those are placeholders. */
 		$content = __(
-// phpcs:ignore Generic.WhiteSpace.ScopeIndent.Incorrect, PEAR.Functions.FunctionCallSignature.Indent
-'Howdy,
+			'Howdy,
 
 Your request to erase your personal data on ###SITENAME### has been completed.
@@ -3943,7 +3940,5 @@
 	 * Filters the body of the data erasure fulfillment notification.
 	 *
-	 * Use {@see 'user_erasure_fulfillment_email_content'} instead.
-	 *
-	 * The email is sent to a user when a their data erasure request is fulfilled
+	 * The email is sent to a user when their data erasure request is fulfilled
 	 * by an administrator.
 	 *
@@ -3954,9 +3949,8 @@
 	 * ###SITEURL###            The URL to the site.
 	 *
-	 * For user request confirmation email content use {@see 'user_request_confirmed_email_content'} instead.
-	 *
 	 * @since 4.9.6
-	 *
-	 * @deprecated 5.8.0 Use {@see 'user_erasure_fulfillment_email_content'} instead. For user request confirmation email content use {@see 'user_request_confirmed_email_content'} instead.
+	 * @deprecated 5.8.0 Use {@see 'user_erasure_fulfillment_email_content'} instead.
+	 *                   For user request confirmation email content
+	 *                   use {@see 'user_request_confirmed_email_content'} instead.
 	 *
 	 * @param string $content The email content.
@@ -3978,5 +3972,5 @@
 		'5.8.0',
 		sprintf(
-			/* translators: 1 & 2: Deprecation replacement options */
+			/* translators: 1 & 2: Deprecation replacement options. */
 			__( '%1$s or %2$s' ),
 			'user_erasure_fulfillment_email_content',
@@ -3988,5 +3982,5 @@
 	 * Filters the body of the data erasure fulfillment notification.
 	 *
-	 * The email is sent to a user when a their data erasure request is fulfilled
+	 * The email is sent to a user when their data erasure request is fulfilled
 	 * by an administrator.
 	 *
@@ -4023,8 +4017,5 @@
 	 * Filters the headers of the data erasure fulfillment notification.
 	 *
-	 * Use {@see 'user_erasure_fulfillment_email_headers'} instead.
-	 *
 	 * @since 5.4.0
-	 *
 	 * @deprecated 5.8.0 Use {@see 'user_erasure_fulfillment_email_headers'} instead.
 	 *
@@ -4045,5 +4036,10 @@
 	 * }
 	 */
-	$headers = apply_filters_deprecated( 'user_erasure_complete_email_headers', array( $headers, $subject, $content, $request_id, $email_data ), '5.8.0', 'user_erasure_fulfillment_email_headers' );
+	$headers = apply_filters_deprecated(
+		'user_erasure_complete_email_headers',
+		array( $headers, $subject, $content, $request_id, $email_data ),
+		'5.8.0',
+		'user_erasure_fulfillment_email_headers'
+	);
 
 	/**
@@ -4291,6 +4287,5 @@
 	/* translators: Do not translate DESCRIPTION, CONFIRM_URL, SITENAME, SITEURL: those are placeholders. */
 	$content = __(
-// phpcs:ignore Generic.WhiteSpace.ScopeIndent.Incorrect, PEAR.Functions.FunctionCallSignature.Indent
-'Howdy,
+		'Howdy,
 
 A request has been made to perform the following action on your account: